<template lang="pug">
div
  transition(
    :key="plugin.visible",
    enter-active-class="animate__animated animate__fadeIn",
    leave-active-class="animate__animated animate__fadeOut"
  )
    .content(v-if="plugin.visible")
      .column.justify-center.full-height
        .slide.full-height.scroll(v-scroll="scroll", ref="scroller")
          //- transition(
          //-   :key="loaded",
          //-   enter-active-class="animate__animated animate__fadeIn",
          //-   leave-active-class="animate__animated animate__fadeOut"
          //- )
          iframe.iframe(
            ref="iframe",
            :src="`https://pip-ed.web.app/${slug}?token=qupIHs92zTOjD1WVClXviwZhT5hFpwellzn4IRVqPUzFldTPNdWWXyVbcaDDWm7T`"
          )
        //- .fit.absolute.light-dimmed.bg-white(v-show="!loaded")
        //-   .row.items-center.fit.justify-center
        //-     .col-auto
        //-       q-spinner(size="xl")
</template>

<script>
import { debounce } from "quasar";

// let interval = null;

export default {
  name: "PipSearchOverlay",
  interval: null,
  props: {
    firebase: {
      required: true,
    },
    context: {
      required: false,
    },
  },
  created() {
    // window.addEventListener("message", this.loadEvent, true);
    // this.interval = setInterval(this.checkIframe, 1000);
  },
  methods: {
    loadEvent(evt) {
      // console.log("loadEvent: ", evt.data, this.plugin.selected.path);
      if (this.plugin && this.plugin.selected && this.plugin.selected.path)
        if (evt.data == `/${this.plugin.selected.path}`) this.loaded = true;
    },
    scroll: debounce(async function (position) {
      // console.log(position);
      try {
        if (this.context.host) {
          await this.firebase
            .ref(
              `config/${this.context.meetingid}/current/currentState/plugins/pipsearch/scroll`
            )
            .set(position);
        }
      } catch {
        //no permissions to do this...(i.e. the client)
      }
    }, 200),
  },
  computed: {
    slug() {
      return this.plugin?.selected?.path ?? "";
    },
  },
  data: () => {
    return {
      parentComponent: this,
      plugin: { selected: {} },
      loaded: false,
    };
  },
  watch: {
    plugin: {
      deep: true,
      handler(nue, old) {
        if (nue.selected && nue.selected?.path != old.selected?.path) {
          this.loaded = false;
        }

        if (nue.scroll != old.scroll) {
          this.$refs.scroller.scrollTo(0, nue.scroll);
        }
      },
    },
    firebase: {
      immediate: true,
      handler() {
        this.$rtdbBind(
          "plugin",
          this.firebase.ref(
            `config/${this.context.meetingid}/current/currentState/plugins/pipsearch`
          )
        );
      },
    },
  },
};
</script>

<style lang="scss" scoped>
.nohighlight {
  mark {
    background: none !important;
    transition: background-color 0.3s ease;
  }
}

.slide {
  scroll-behavior: smooth;
}

.content {
  position: absolute;
  height: 660px;
  width: 480px;
  top: 10px;
  left: 10px;
  background: white;
  border-radius: 5px;
  // padding: 10px;
  font-size: 20px;
  filter: drop-shadow(0 0 10px black);
  overflow: hidden;
  // transform: perspective(1500px) rotateY(15deg);
}

.iframe {
  border: none;
  width: 100%;
  height: 10000px;
}
</style>
